# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import meta_v1


@dataclass_json
@dataclass
class MutatingWebhook:
    clientConfig: 'WebhookClientConfig'
    name: 'str'
    admissionReviewVersions: 'List[str]' = None
    failurePolicy: 'str' = None
    matchPolicy: 'str' = None
    namespaceSelector: 'meta_v1.LabelSelector' = None
    objectSelector: 'meta_v1.LabelSelector' = None
    reinvocationPolicy: 'str' = None
    rules: 'List[RuleWithOperations]' = None
    sideEffects: 'str' = None
    timeoutSeconds: 'int' = None


@dataclass_json
@dataclass
class MutatingWebhookConfiguration:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    webhooks: 'List[MutatingWebhook]' = None


@dataclass_json
@dataclass
class MutatingWebhookConfigurationList:
    items: 'List[MutatingWebhookConfiguration]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class RuleWithOperations:
    apiGroups: 'List[str]' = None
    apiVersions: 'List[str]' = None
    operations: 'List[str]' = None
    resources: 'List[str]' = None
    scope: 'str' = None


@dataclass_json
@dataclass
class ServiceReference:
    name: 'str'
    namespace: 'str'
    path: 'str' = None
    port: 'int' = None


@dataclass_json
@dataclass
class ValidatingWebhook:
    clientConfig: 'WebhookClientConfig'
    name: 'str'
    admissionReviewVersions: 'List[str]' = None
    failurePolicy: 'str' = None
    matchPolicy: 'str' = None
    namespaceSelector: 'meta_v1.LabelSelector' = None
    objectSelector: 'meta_v1.LabelSelector' = None
    rules: 'List[RuleWithOperations]' = None
    sideEffects: 'str' = None
    timeoutSeconds: 'int' = None


@dataclass_json
@dataclass
class ValidatingWebhookConfiguration:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    webhooks: 'List[ValidatingWebhook]' = None


@dataclass_json
@dataclass
class ValidatingWebhookConfigurationList:
    items: 'List[ValidatingWebhookConfiguration]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class WebhookClientConfig:
    caBundle: 'str' = None
    service: 'ServiceReference' = None
    url: 'str' = None


