# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import core_v1
from . import runtime
from . import util_intstr
from . import meta_v1


@dataclass_json
@dataclass
class ControllerRevision:
    revision: 'int'
    apiVersion: 'str' = None
    data: 'runtime.RawExtension' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass_json
@dataclass
class ControllerRevisionList:
    items: 'List[ControllerRevision]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class Deployment:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'DeploymentSpec' = None
    status: 'DeploymentStatus' = None


@dataclass_json
@dataclass
class DeploymentCondition:
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    lastUpdateTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class DeploymentList:
    items: 'List[Deployment]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class DeploymentRollback:
    name: 'str'
    rollbackTo: 'RollbackConfig'
    apiVersion: 'str' = None
    kind: 'str' = None
    updatedAnnotations: 'dict' = None


@dataclass_json
@dataclass
class DeploymentSpec:
    template: 'core_v1.PodTemplateSpec'
    minReadySeconds: 'int' = None
    paused: 'bool' = None
    progressDeadlineSeconds: 'int' = None
    replicas: 'int' = None
    revisionHistoryLimit: 'int' = None
    rollbackTo: 'RollbackConfig' = None
    selector: 'meta_v1.LabelSelector' = None
    strategy: 'DeploymentStrategy' = None


@dataclass_json
@dataclass
class DeploymentStatus:
    availableReplicas: 'int' = None
    collisionCount: 'int' = None
    conditions: 'List[DeploymentCondition]' = None
    observedGeneration: 'int' = None
    readyReplicas: 'int' = None
    replicas: 'int' = None
    unavailableReplicas: 'int' = None
    updatedReplicas: 'int' = None


@dataclass_json
@dataclass
class DeploymentStrategy:
    rollingUpdate: 'RollingUpdateDeployment' = None
    type: 'str' = None


@dataclass_json
@dataclass
class RollbackConfig:
    revision: 'int' = None


@dataclass_json
@dataclass
class RollingUpdateDeployment:
    maxSurge: 'util_intstr.IntOrString' = None
    maxUnavailable: 'util_intstr.IntOrString' = None


@dataclass_json
@dataclass
class RollingUpdateStatefulSetStrategy:
    partition: 'int' = None


@dataclass_json
@dataclass
class Scale:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ScaleSpec' = None
    status: 'ScaleStatus' = None


@dataclass_json
@dataclass
class ScaleSpec:
    replicas: 'int' = None


@dataclass_json
@dataclass
class ScaleStatus:
    replicas: 'int'
    selector: 'dict' = None
    targetSelector: 'str' = None


@dataclass_json
@dataclass
class StatefulSet:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'StatefulSetSpec' = None
    status: 'StatefulSetStatus' = None


@dataclass_json
@dataclass
class StatefulSetCondition:
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class StatefulSetList:
    items: 'List[StatefulSet]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class StatefulSetSpec:
    serviceName: 'str'
    template: 'core_v1.PodTemplateSpec'
    podManagementPolicy: 'str' = None
    replicas: 'int' = None
    revisionHistoryLimit: 'int' = None
    selector: 'meta_v1.LabelSelector' = None
    updateStrategy: 'StatefulSetUpdateStrategy' = None
    volumeClaimTemplates: 'List[core_v1.PersistentVolumeClaim]' = None


@dataclass_json
@dataclass
class StatefulSetStatus:
    replicas: 'int'
    collisionCount: 'int' = None
    conditions: 'List[StatefulSetCondition]' = None
    currentReplicas: 'int' = None
    currentRevision: 'str' = None
    observedGeneration: 'int' = None
    readyReplicas: 'int' = None
    updateRevision: 'str' = None
    updatedReplicas: 'int' = None


@dataclass_json
@dataclass
class StatefulSetUpdateStrategy:
    rollingUpdate: 'RollingUpdateStatefulSetStrategy' = None
    type: 'str' = None


