# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import meta_v1


@dataclass_json
@dataclass
class LocalSubjectAccessReview:
    spec: 'SubjectAccessReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectAccessReviewStatus' = None


@dataclass_json
@dataclass
class NonResourceAttributes:
    path: 'str' = None
    verb: 'str' = None


@dataclass_json
@dataclass
class NonResourceRule:
    verbs: 'List[str]'
    nonResourceURLs: 'List[str]' = None


@dataclass_json
@dataclass
class ResourceAttributes:
    group: 'str' = None
    name: 'str' = None
    namespace: 'str' = None
    resource: 'str' = None
    subresource: 'str' = None
    verb: 'str' = None
    version: 'str' = None


@dataclass_json
@dataclass
class ResourceRule:
    verbs: 'List[str]'
    apiGroups: 'List[str]' = None
    resourceNames: 'List[str]' = None
    resources: 'List[str]' = None


@dataclass_json
@dataclass
class SelfSubjectAccessReview:
    spec: 'SelfSubjectAccessReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectAccessReviewStatus' = None


@dataclass_json
@dataclass
class SelfSubjectAccessReviewSpec:
    nonResourceAttributes: 'NonResourceAttributes' = None
    resourceAttributes: 'ResourceAttributes' = None


@dataclass_json
@dataclass
class SelfSubjectRulesReview:
    spec: 'SelfSubjectRulesReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectRulesReviewStatus' = None


@dataclass_json
@dataclass
class SelfSubjectRulesReviewSpec:
    namespace: 'str' = None


@dataclass_json
@dataclass
class SubjectAccessReview:
    spec: 'SubjectAccessReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectAccessReviewStatus' = None


@dataclass_json
@dataclass
class SubjectAccessReviewSpec:
    extra: 'dict' = None
    group: 'List[str]' = None
    nonResourceAttributes: 'NonResourceAttributes' = None
    resourceAttributes: 'ResourceAttributes' = None
    uid: 'str' = None
    user: 'str' = None


@dataclass_json
@dataclass
class SubjectAccessReviewStatus:
    allowed: 'bool'
    denied: 'bool' = None
    evaluationError: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class SubjectRulesReviewStatus:
    incomplete: 'bool'
    nonResourceRules: 'List[NonResourceRule]'
    resourceRules: 'List[ResourceRule]'
    evaluationError: 'str' = None


