# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import meta_v1


@dataclass_json
@dataclass
class CrossVersionObjectReference:
    kind: 'str'
    name: 'str'
    apiVersion: 'str' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscaler:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'HorizontalPodAutoscalerSpec' = None
    status: 'HorizontalPodAutoscalerStatus' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerList:
    items: 'List[HorizontalPodAutoscaler]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerSpec:
    maxReplicas: 'int'
    scaleTargetRef: 'CrossVersionObjectReference'
    minReplicas: 'int' = None
    targetCPUUtilizationPercentage: 'int' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerStatus:
    currentReplicas: 'int'
    desiredReplicas: 'int'
    currentCPUUtilizationPercentage: 'int' = None
    lastScaleTime: 'meta_v1.Time' = None
    observedGeneration: 'int' = None


@dataclass_json
@dataclass
class Scale:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ScaleSpec' = None
    status: 'ScaleStatus' = None


@dataclass_json
@dataclass
class ScaleSpec:
    replicas: 'int' = None


@dataclass_json
@dataclass
class ScaleStatus:
    replicas: 'int'
    selector: 'str' = None


