# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import resource
from . import meta_v1


@dataclass_json
@dataclass
class CrossVersionObjectReference:
    kind: 'str'
    name: 'str'
    apiVersion: 'str' = None


@dataclass_json
@dataclass
class ExternalMetricSource:
    metricName: 'str'
    metricSelector: 'meta_v1.LabelSelector' = None
    targetAverageValue: 'resource.Quantity' = None
    targetValue: 'resource.Quantity' = None


@dataclass_json
@dataclass
class ExternalMetricStatus:
    currentValue: 'resource.Quantity'
    metricName: 'str'
    currentAverageValue: 'resource.Quantity' = None
    metricSelector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscaler:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'HorizontalPodAutoscalerSpec' = None
    status: 'HorizontalPodAutoscalerStatus' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerCondition:
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerList:
    items: 'List[HorizontalPodAutoscaler]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerSpec:
    maxReplicas: 'int'
    scaleTargetRef: 'CrossVersionObjectReference'
    metrics: 'List[MetricSpec]' = None
    minReplicas: 'int' = None


@dataclass_json
@dataclass
class HorizontalPodAutoscalerStatus:
    conditions: 'List[HorizontalPodAutoscalerCondition]'
    currentReplicas: 'int'
    desiredReplicas: 'int'
    currentMetrics: 'List[MetricStatus]' = None
    lastScaleTime: 'meta_v1.Time' = None
    observedGeneration: 'int' = None


@dataclass_json
@dataclass
class MetricSpec:
    type: 'str'
    external: 'ExternalMetricSource' = None
    object: 'ObjectMetricSource' = None
    pods: 'PodsMetricSource' = None
    resource: 'ResourceMetricSource' = None


@dataclass_json
@dataclass
class MetricStatus:
    type: 'str'
    external: 'ExternalMetricStatus' = None
    object: 'ObjectMetricStatus' = None
    pods: 'PodsMetricStatus' = None
    resource: 'ResourceMetricStatus' = None


@dataclass_json
@dataclass
class ObjectMetricSource:
    metricName: 'str'
    target: 'CrossVersionObjectReference'
    targetValue: 'resource.Quantity'
    averageValue: 'resource.Quantity' = None
    selector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class ObjectMetricStatus:
    currentValue: 'resource.Quantity'
    metricName: 'str'
    target: 'CrossVersionObjectReference'
    averageValue: 'resource.Quantity' = None
    selector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class PodsMetricSource:
    metricName: 'str'
    targetAverageValue: 'resource.Quantity'
    selector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class PodsMetricStatus:
    currentAverageValue: 'resource.Quantity'
    metricName: 'str'
    selector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class ResourceMetricSource:
    name: 'str'
    targetAverageUtilization: 'int' = None
    targetAverageValue: 'resource.Quantity' = None


@dataclass_json
@dataclass
class ResourceMetricStatus:
    currentAverageValue: 'resource.Quantity'
    name: 'str'
    currentAverageUtilization: 'int' = None


