# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import core_v1
from . import util_intstr
from . import meta_v1


@dataclass_json
@dataclass
class AllowedCSIDriver:
    name: 'str'


@dataclass_json
@dataclass
class AllowedFlexVolume:
    driver: 'str'


@dataclass_json
@dataclass
class AllowedHostPath:
    pathPrefix: 'str' = None
    readOnly: 'bool' = None


@dataclass_json
@dataclass
class DaemonSet:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'DaemonSetSpec' = None
    status: 'DaemonSetStatus' = None


@dataclass_json
@dataclass
class DaemonSetCondition:
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class DaemonSetList:
    items: 'List[DaemonSet]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class DaemonSetSpec:
    template: 'core_v1.PodTemplateSpec'
    minReadySeconds: 'int' = None
    revisionHistoryLimit: 'int' = None
    selector: 'meta_v1.LabelSelector' = None
    templateGeneration: 'int' = None
    updateStrategy: 'DaemonSetUpdateStrategy' = None


@dataclass_json
@dataclass
class DaemonSetStatus:
    currentNumberScheduled: 'int'
    desiredNumberScheduled: 'int'
    numberMisscheduled: 'int'
    numberReady: 'int'
    collisionCount: 'int' = None
    conditions: 'List[DaemonSetCondition]' = None
    numberAvailable: 'int' = None
    numberUnavailable: 'int' = None
    observedGeneration: 'int' = None
    updatedNumberScheduled: 'int' = None


@dataclass_json
@dataclass
class DaemonSetUpdateStrategy:
    rollingUpdate: 'RollingUpdateDaemonSet' = None
    type: 'str' = None


@dataclass_json
@dataclass
class Deployment:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'DeploymentSpec' = None
    status: 'DeploymentStatus' = None


@dataclass_json
@dataclass
class DeploymentCondition:
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    lastUpdateTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class DeploymentList:
    items: 'List[Deployment]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class DeploymentRollback:
    name: 'str'
    rollbackTo: 'RollbackConfig'
    apiVersion: 'str' = None
    kind: 'str' = None
    updatedAnnotations: 'dict' = None


@dataclass_json
@dataclass
class DeploymentSpec:
    template: 'core_v1.PodTemplateSpec'
    minReadySeconds: 'int' = None
    paused: 'bool' = None
    progressDeadlineSeconds: 'int' = None
    replicas: 'int' = None
    revisionHistoryLimit: 'int' = None
    rollbackTo: 'RollbackConfig' = None
    selector: 'meta_v1.LabelSelector' = None
    strategy: 'DeploymentStrategy' = None


@dataclass_json
@dataclass
class DeploymentStatus:
    availableReplicas: 'int' = None
    collisionCount: 'int' = None
    conditions: 'List[DeploymentCondition]' = None
    observedGeneration: 'int' = None
    readyReplicas: 'int' = None
    replicas: 'int' = None
    unavailableReplicas: 'int' = None
    updatedReplicas: 'int' = None


@dataclass_json
@dataclass
class DeploymentStrategy:
    rollingUpdate: 'RollingUpdateDeployment' = None
    type: 'str' = None


@dataclass_json
@dataclass
class FSGroupStrategyOptions:
    ranges: 'List[IDRange]' = None
    rule: 'str' = None


@dataclass_json
@dataclass
class HTTPIngressPath:
    backend: 'IngressBackend'
    path: 'str' = None


@dataclass_json
@dataclass
class HTTPIngressRuleValue:
    paths: 'List[HTTPIngressPath]'


@dataclass_json
@dataclass
class HostPortRange:
    max: 'int'
    min: 'int'


@dataclass_json
@dataclass
class IDRange:
    max: 'int'
    min: 'int'


@dataclass_json
@dataclass
class IPBlock:
    cidr: 'str'
    except_: 'List[str]' = field(metadata={"json": "except"}, default=None)


@dataclass_json
@dataclass
class Ingress:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'IngressSpec' = None
    status: 'IngressStatus' = None


@dataclass_json
@dataclass
class IngressBackend:
    serviceName: 'str'
    servicePort: 'util_intstr.IntOrString'


@dataclass_json
@dataclass
class IngressList:
    items: 'List[Ingress]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class IngressRule:
    host: 'str' = None
    http: 'HTTPIngressRuleValue' = None


@dataclass_json
@dataclass
class IngressSpec:
    backend: 'IngressBackend' = None
    rules: 'List[IngressRule]' = None
    tls: 'List[IngressTLS]' = None


@dataclass_json
@dataclass
class IngressStatus:
    loadBalancer: 'core_v1.LoadBalancerStatus' = None


@dataclass_json
@dataclass
class IngressTLS:
    hosts: 'List[str]' = None
    secretName: 'str' = None


@dataclass_json
@dataclass
class NetworkPolicy:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'NetworkPolicySpec' = None


@dataclass_json
@dataclass
class NetworkPolicyEgressRule:
    ports: 'List[NetworkPolicyPort]' = None
    to: 'List[NetworkPolicyPeer]' = None


@dataclass_json
@dataclass
class NetworkPolicyIngressRule:
    from_: 'List[NetworkPolicyPeer]' = field(metadata={"json": "from"}, default=None)
    ports: 'List[NetworkPolicyPort]' = None


@dataclass_json
@dataclass
class NetworkPolicyList:
    items: 'List[NetworkPolicy]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class NetworkPolicyPeer:
    ipBlock: 'IPBlock' = None
    namespaceSelector: 'meta_v1.LabelSelector' = None
    podSelector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class NetworkPolicyPort:
    port: 'util_intstr.IntOrString' = None
    protocol: 'str' = None


@dataclass_json
@dataclass
class NetworkPolicySpec:
    podSelector: 'meta_v1.LabelSelector'
    egress: 'List[NetworkPolicyEgressRule]' = None
    ingress: 'List[NetworkPolicyIngressRule]' = None
    policyTypes: 'List[str]' = None


@dataclass_json
@dataclass
class PodSecurityPolicy:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PodSecurityPolicySpec' = None


@dataclass_json
@dataclass
class PodSecurityPolicyList:
    items: 'List[PodSecurityPolicy]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class PodSecurityPolicySpec:
    fsGroup: 'FSGroupStrategyOptions'
    runAsUser: 'RunAsUserStrategyOptions'
    seLinux: 'SELinuxStrategyOptions'
    supplementalGroups: 'SupplementalGroupsStrategyOptions'
    allowPrivilegeEscalation: 'bool' = None
    allowedCSIDrivers: 'List[AllowedCSIDriver]' = None
    allowedCapabilities: 'List[str]' = None
    allowedFlexVolumes: 'List[AllowedFlexVolume]' = None
    allowedHostPaths: 'List[AllowedHostPath]' = None
    allowedProcMountTypes: 'List[str]' = None
    allowedUnsafeSysctls: 'List[str]' = None
    defaultAddCapabilities: 'List[str]' = None
    defaultAllowPrivilegeEscalation: 'bool' = None
    forbiddenSysctls: 'List[str]' = None
    hostIPC: 'bool' = None
    hostNetwork: 'bool' = None
    hostPID: 'bool' = None
    hostPorts: 'List[HostPortRange]' = None
    privileged: 'bool' = None
    readOnlyRootFilesystem: 'bool' = None
    requiredDropCapabilities: 'List[str]' = None
    runAsGroup: 'RunAsGroupStrategyOptions' = None
    runtimeClass: 'RuntimeClassStrategyOptions' = None
    volumes: 'List[str]' = None


@dataclass_json
@dataclass
class ReplicaSet:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ReplicaSetSpec' = None
    status: 'ReplicaSetStatus' = None


@dataclass_json
@dataclass
class ReplicaSetCondition:
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class ReplicaSetList:
    items: 'List[ReplicaSet]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class ReplicaSetSpec:
    minReadySeconds: 'int' = None
    replicas: 'int' = None
    selector: 'meta_v1.LabelSelector' = None
    template: 'core_v1.PodTemplateSpec' = None


@dataclass_json
@dataclass
class ReplicaSetStatus:
    replicas: 'int'
    availableReplicas: 'int' = None
    conditions: 'List[ReplicaSetCondition]' = None
    fullyLabeledReplicas: 'int' = None
    observedGeneration: 'int' = None
    readyReplicas: 'int' = None


@dataclass_json
@dataclass
class RollbackConfig:
    revision: 'int' = None


@dataclass_json
@dataclass
class RollingUpdateDaemonSet:
    maxUnavailable: 'util_intstr.IntOrString' = None


@dataclass_json
@dataclass
class RollingUpdateDeployment:
    maxSurge: 'util_intstr.IntOrString' = None
    maxUnavailable: 'util_intstr.IntOrString' = None


@dataclass_json
@dataclass
class RunAsGroupStrategyOptions:
    rule: 'str'
    ranges: 'List[IDRange]' = None


@dataclass_json
@dataclass
class RunAsUserStrategyOptions:
    rule: 'str'
    ranges: 'List[IDRange]' = None


@dataclass_json
@dataclass
class RuntimeClassStrategyOptions:
    allowedRuntimeClassNames: 'List[str]'
    defaultRuntimeClassName: 'str' = None


@dataclass_json
@dataclass
class SELinuxStrategyOptions:
    rule: 'str'
    seLinuxOptions: 'core_v1.SELinuxOptions' = None


@dataclass_json
@dataclass
class Scale:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ScaleSpec' = None
    status: 'ScaleStatus' = None


@dataclass_json
@dataclass
class ScaleSpec:
    replicas: 'int' = None


@dataclass_json
@dataclass
class ScaleStatus:
    replicas: 'int'
    selector: 'dict' = None
    targetSelector: 'str' = None


@dataclass_json
@dataclass
class SupplementalGroupsStrategyOptions:
    ranges: 'List[IDRange]' = None
    rule: 'str' = None


