# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import runtime
from datetime import datetime
from typing import Dict


@dataclass_json
@dataclass
class APIGroup:
    name: 'str'
    versions: 'List[GroupVersionForDiscovery]'
    apiVersion: 'str' = None
    kind: 'str' = None
    preferredVersion: 'GroupVersionForDiscovery' = None
    serverAddressByClientCIDRs: 'List[ServerAddressByClientCIDR]' = None


@dataclass_json
@dataclass
class APIGroupList:
    groups: 'List[APIGroup]'
    apiVersion: 'str' = None
    kind: 'str' = None


@dataclass_json
@dataclass
class APIResource:
    kind: 'str'
    name: 'str'
    namespaced: 'bool'
    singularName: 'str'
    verbs: 'List[str]'
    categories: 'List[str]' = None
    group: 'str' = None
    shortNames: 'List[str]' = None
    storageVersionHash: 'str' = None
    version: 'str' = None


@dataclass_json
@dataclass
class APIResourceList:
    groupVersion: 'str'
    resources: 'List[APIResource]'
    apiVersion: 'str' = None
    kind: 'str' = None


@dataclass_json
@dataclass
class APIVersions:
    serverAddressByClientCIDRs: 'List[ServerAddressByClientCIDR]'
    versions: 'List[str]'
    apiVersion: 'str' = None
    kind: 'str' = None


@dataclass_json
@dataclass
class DeleteOptions:
    apiVersion: 'str' = None
    dryRun: 'List[str]' = None
    gracePeriodSeconds: 'int' = None
    kind: 'str' = None
    orphanDependents: 'bool' = None
    preconditions: 'Preconditions' = None
    propagationPolicy: 'str' = None


Fields = Dict


@dataclass_json
@dataclass
class GroupVersionForDiscovery:
    groupVersion: 'str'
    version: 'str'


@dataclass_json
@dataclass
class Initializer:
    name: 'str'


@dataclass_json
@dataclass
class Initializers:
    pending: 'List[Initializer]'
    result: 'Status' = None


@dataclass_json
@dataclass
class LabelSelector:
    matchExpressions: 'List[LabelSelectorRequirement]' = None
    matchLabels: 'dict' = None


@dataclass_json
@dataclass
class LabelSelectorRequirement:
    key: 'str'
    operator: 'str'
    values: 'List[str]' = None


@dataclass_json
@dataclass
class ListMeta:
    continue_: 'str' = field(metadata={"json": "continue"}, default=None)
    remainingItemCount: 'int' = None
    resourceVersion: 'str' = None
    selfLink: 'str' = None


@dataclass_json
@dataclass
class ManagedFieldsEntry:
    apiVersion: 'str' = None
    fields: 'Fields' = None
    manager: 'str' = None
    operation: 'str' = None
    time: 'Time' = None


MicroTime = datetime


@dataclass_json
@dataclass
class ObjectMeta:
    annotations: 'dict' = None
    clusterName: 'str' = None
    creationTimestamp: 'Time' = None
    deletionGracePeriodSeconds: 'int' = None
    deletionTimestamp: 'Time' = None
    finalizers: 'List[str]' = None
    generateName: 'str' = None
    generation: 'int' = None
    initializers: 'Initializers' = None
    labels: 'dict' = None
    managedFields: 'List[ManagedFieldsEntry]' = None
    name: 'str' = None
    namespace: 'str' = None
    ownerReferences: 'List[OwnerReference]' = None
    resourceVersion: 'str' = None
    selfLink: 'str' = None
    uid: 'str' = None


@dataclass_json
@dataclass
class OwnerReference:
    apiVersion: 'str'
    kind: 'str'
    name: 'str'
    uid: 'str'
    blockOwnerDeletion: 'bool' = None
    controller: 'bool' = None


Patch = Dict


@dataclass_json
@dataclass
class Preconditions:
    resourceVersion: 'str' = None
    uid: 'str' = None


@dataclass_json
@dataclass
class ServerAddressByClientCIDR:
    clientCIDR: 'str'
    serverAddress: 'str'


@dataclass_json
@dataclass
class Status:
    apiVersion: 'str' = None
    code: 'int' = None
    details: 'StatusDetails' = None
    kind: 'str' = None
    message: 'str' = None
    metadata: 'ListMeta' = None
    reason: 'str' = None
    status: 'str' = None


@dataclass_json
@dataclass
class StatusCause:
    field: 'str' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass_json
@dataclass
class StatusDetails:
    causes: 'List[StatusCause]' = None
    group: 'str' = None
    kind: 'str' = None
    name: 'str' = None
    retryAfterSeconds: 'int' = None
    uid: 'str' = None


Time = datetime


@dataclass_json
@dataclass
class WatchEvent:
    object: 'runtime.RawExtension'
    type: 'str'


