# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import core_v1
from . import util_intstr
from . import meta_v1


@dataclass_json
@dataclass
class HTTPIngressPath:
    backend: 'IngressBackend'
    path: 'str' = None


@dataclass_json
@dataclass
class HTTPIngressRuleValue:
    paths: 'List[HTTPIngressPath]'


@dataclass_json
@dataclass
class Ingress:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'IngressSpec' = None
    status: 'IngressStatus' = None


@dataclass_json
@dataclass
class IngressBackend:
    serviceName: 'str'
    servicePort: 'util_intstr.IntOrString'


@dataclass_json
@dataclass
class IngressList:
    items: 'List[Ingress]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class IngressRule:
    host: 'str' = None
    http: 'HTTPIngressRuleValue' = None


@dataclass_json
@dataclass
class IngressSpec:
    backend: 'IngressBackend' = None
    rules: 'List[IngressRule]' = None
    tls: 'List[IngressTLS]' = None


@dataclass_json
@dataclass
class IngressStatus:
    loadBalancer: 'core_v1.LoadBalancerStatus' = None


@dataclass_json
@dataclass
class IngressTLS:
    hosts: 'List[str]' = None
    secretName: 'str' = None


