# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import core_v1
from . import util_intstr
from . import meta_v1


@dataclass_json
@dataclass
class AllowedCSIDriver:
    name: 'str'


@dataclass_json
@dataclass
class AllowedFlexVolume:
    driver: 'str'


@dataclass_json
@dataclass
class AllowedHostPath:
    pathPrefix: 'str' = None
    readOnly: 'bool' = None


@dataclass_json
@dataclass
class Eviction:
    apiVersion: 'str' = None
    deleteOptions: 'meta_v1.DeleteOptions' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass_json
@dataclass
class FSGroupStrategyOptions:
    ranges: 'List[IDRange]' = None
    rule: 'str' = None


@dataclass_json
@dataclass
class HostPortRange:
    max: 'int'
    min: 'int'


@dataclass_json
@dataclass
class IDRange:
    max: 'int'
    min: 'int'


@dataclass_json
@dataclass
class PodDisruptionBudget:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PodDisruptionBudgetSpec' = None
    status: 'PodDisruptionBudgetStatus' = None


@dataclass_json
@dataclass
class PodDisruptionBudgetList:
    items: 'List[PodDisruptionBudget]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class PodDisruptionBudgetSpec:
    maxUnavailable: 'util_intstr.IntOrString' = None
    minAvailable: 'util_intstr.IntOrString' = None
    selector: 'meta_v1.LabelSelector' = None


@dataclass_json
@dataclass
class PodDisruptionBudgetStatus:
    currentHealthy: 'int'
    desiredHealthy: 'int'
    disruptionsAllowed: 'int'
    expectedPods: 'int'
    disruptedPods: 'dict' = None
    observedGeneration: 'int' = None


@dataclass_json
@dataclass
class PodSecurityPolicy:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PodSecurityPolicySpec' = None


@dataclass_json
@dataclass
class PodSecurityPolicyList:
    items: 'List[PodSecurityPolicy]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class PodSecurityPolicySpec:
    fsGroup: 'FSGroupStrategyOptions'
    runAsUser: 'RunAsUserStrategyOptions'
    seLinux: 'SELinuxStrategyOptions'
    supplementalGroups: 'SupplementalGroupsStrategyOptions'
    allowPrivilegeEscalation: 'bool' = None
    allowedCSIDrivers: 'List[AllowedCSIDriver]' = None
    allowedCapabilities: 'List[str]' = None
    allowedFlexVolumes: 'List[AllowedFlexVolume]' = None
    allowedHostPaths: 'List[AllowedHostPath]' = None
    allowedProcMountTypes: 'List[str]' = None
    allowedUnsafeSysctls: 'List[str]' = None
    defaultAddCapabilities: 'List[str]' = None
    defaultAllowPrivilegeEscalation: 'bool' = None
    forbiddenSysctls: 'List[str]' = None
    hostIPC: 'bool' = None
    hostNetwork: 'bool' = None
    hostPID: 'bool' = None
    hostPorts: 'List[HostPortRange]' = None
    privileged: 'bool' = None
    readOnlyRootFilesystem: 'bool' = None
    requiredDropCapabilities: 'List[str]' = None
    runAsGroup: 'RunAsGroupStrategyOptions' = None
    runtimeClass: 'RuntimeClassStrategyOptions' = None
    volumes: 'List[str]' = None


@dataclass_json
@dataclass
class RunAsGroupStrategyOptions:
    rule: 'str'
    ranges: 'List[IDRange]' = None


@dataclass_json
@dataclass
class RunAsUserStrategyOptions:
    rule: 'str'
    ranges: 'List[IDRange]' = None


@dataclass_json
@dataclass
class RuntimeClassStrategyOptions:
    allowedRuntimeClassNames: 'List[str]'
    defaultRuntimeClassName: 'str' = None


@dataclass_json
@dataclass
class SELinuxStrategyOptions:
    rule: 'str'
    seLinuxOptions: 'core_v1.SELinuxOptions' = None


@dataclass_json
@dataclass
class SupplementalGroupsStrategyOptions:
    ranges: 'List[IDRange]' = None
    rule: 'str' = None


