# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import meta_v1


@dataclass_json
@dataclass
class AggregationRule:
    clusterRoleSelectors: 'List[meta_v1.LabelSelector]' = None


@dataclass_json
@dataclass
class ClusterRole:
    aggregationRule: 'AggregationRule' = None
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    rules: 'List[PolicyRule]' = None


@dataclass_json
@dataclass
class ClusterRoleBinding:
    roleRef: 'RoleRef'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    subjects: 'List[Subject]' = None


@dataclass_json
@dataclass
class ClusterRoleBindingList:
    items: 'List[ClusterRoleBinding]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class ClusterRoleList:
    items: 'List[ClusterRole]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class PolicyRule:
    verbs: 'List[str]'
    apiGroups: 'List[str]' = None
    nonResourceURLs: 'List[str]' = None
    resourceNames: 'List[str]' = None
    resources: 'List[str]' = None


@dataclass_json
@dataclass
class Role:
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    rules: 'List[PolicyRule]' = None


@dataclass_json
@dataclass
class RoleBinding:
    roleRef: 'RoleRef'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    subjects: 'List[Subject]' = None


@dataclass_json
@dataclass
class RoleBindingList:
    items: 'List[RoleBinding]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class RoleList:
    items: 'List[Role]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class RoleRef:
    apiGroup: 'str'
    kind: 'str'
    name: 'str'


@dataclass_json
@dataclass
class Subject:
    kind: 'str'
    name: 'str'
    apiGroup: 'str' = None
    namespace: 'str' = None


