# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_json import dataclass_json

from . import core_v1
from . import meta_v1


@dataclass_json
@dataclass
class CSIDriver:
    spec: 'CSIDriverSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass_json
@dataclass
class CSIDriverList:
    items: 'List[CSIDriver]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class CSIDriverSpec:
    attachRequired: 'bool' = None
    podInfoOnMount: 'bool' = None


@dataclass_json
@dataclass
class CSINode:
    spec: 'CSINodeSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass_json
@dataclass
class CSINodeDriver:
    name: 'str'
    nodeID: 'str'
    topologyKeys: 'List[str]' = None


@dataclass_json
@dataclass
class CSINodeList:
    items: 'List[CSINode]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class CSINodeSpec:
    drivers: 'List[CSINodeDriver]'


@dataclass_json
@dataclass
class StorageClass:
    provisioner: 'str'
    allowVolumeExpansion: 'bool' = None
    allowedTopologies: 'List[core_v1.TopologySelectorTerm]' = None
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    mountOptions: 'List[str]' = None
    parameters: 'dict' = None
    reclaimPolicy: 'str' = None
    volumeBindingMode: 'str' = None


@dataclass_json
@dataclass
class StorageClassList:
    items: 'List[StorageClass]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class VolumeAttachment:
    spec: 'VolumeAttachmentSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'VolumeAttachmentStatus' = None


@dataclass_json
@dataclass
class VolumeAttachmentList:
    items: 'List[VolumeAttachment]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass_json
@dataclass
class VolumeAttachmentSource:
    inlineVolumeSpec: 'core_v1.PersistentVolumeSpec' = None
    persistentVolumeName: 'str' = None


@dataclass_json
@dataclass
class VolumeAttachmentSpec:
    attacher: 'str'
    nodeName: 'str'
    source: 'VolumeAttachmentSource'


@dataclass_json
@dataclass
class VolumeAttachmentStatus:
    attached: 'bool'
    attachError: 'VolumeError' = None
    attachmentMetadata: 'dict' = None
    detachError: 'VolumeError' = None


@dataclass_json
@dataclass
class VolumeError:
    message: 'str' = None
    time: 'meta_v1.Time' = None


