# autogenerated module
from typing import ClassVar

from ..core import resource as res
from ..models import policy_v1beta1 as m_policy_v1beta1
from ..models import core_v1 as m_core_v1
from ..models import autoscaling_v1 as m_autoscaling_v1


class ComponentStatus(res.GlobalResource, m_core_v1.ComponentStatus):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ComponentStatus'),
        plural='componentstatuses',
        verbs=['get', 'list', 'watch'],
    )


class ConfigMap(res.NamespacedResourceG, m_core_v1.ConfigMap):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ConfigMap'),
        plural='configmaps',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class Endpoints(res.NamespacedResourceG, m_core_v1.Endpoints):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Endpoints'),
        plural='endpoints',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class Event(res.NamespacedResourceG, m_core_v1.Event):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Event'),
        plural='events',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class LimitRange(res.NamespacedResourceG, m_core_v1.LimitRange):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'LimitRange'),
        plural='limitranges',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class NamespaceFinalize(res.GlobalSubResource, m_core_v1.Namespace):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Namespace'),
        parent=res.ResourceDef('', 'v1', 'Namespace'),
        plural='namespaces',
        verbs=['put'],
        action='finalize',
    )


class NamespaceStatus(res.GlobalSubResource, m_core_v1.Namespace):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Namespace'),
        parent=res.ResourceDef('', 'v1', 'Namespace'),
        plural='namespaces',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class Namespace(res.GlobalResource, m_core_v1.Namespace):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Namespace'),
        plural='namespaces',
        verbs=['delete', 'get', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Finalize: ClassVar = NamespaceFinalize
    Status: ClassVar = NamespaceStatus


class Binding(res.NamespacedResource, m_core_v1.Binding):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Binding'),
        plural='bindings',
        verbs=['post'],
    )


class PersistentVolumeClaimStatus(res.NamespacedSubResource, m_core_v1.PersistentVolumeClaim):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'PersistentVolumeClaim'),
        parent=res.ResourceDef('', 'v1', 'PersistentVolumeClaim'),
        plural='persistentvolumeclaims',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class PersistentVolumeClaim(res.NamespacedResourceG, m_core_v1.PersistentVolumeClaim):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'PersistentVolumeClaim'),
        plural='persistentvolumeclaims',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = PersistentVolumeClaimStatus


class PodBinding(res.NamespacedSubResource, m_core_v1.Binding):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Binding'),
        parent=res.ResourceDef('', 'v1', 'Pod'),
        plural='pods',
        verbs=['post'],
        action='binding',
    )


class PodEviction(res.NamespacedSubResource, m_policy_v1beta1.Eviction):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('policy', 'v1beta1', 'Eviction'),
        parent=res.ResourceDef('', 'v1', 'Pod'),
        plural='pods',
        verbs=['post'],
        action='eviction',
    )


class PodLog(res.NamespacedSubResource, m_core_v1.Pod):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Pod'),
        parent=res.ResourceDef('', 'v1', 'Pod'),
        plural='pods',
        verbs=['get'],
        action='log',
    )


class PodStatus(res.NamespacedSubResource, m_core_v1.Pod):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Pod'),
        parent=res.ResourceDef('', 'v1', 'Pod'),
        plural='pods',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class Pod(res.NamespacedResourceG, m_core_v1.Pod):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Pod'),
        plural='pods',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Binding: ClassVar = PodBinding
    Eviction: ClassVar = PodEviction
    Log: ClassVar = PodLog
    Status: ClassVar = PodStatus


class PodTemplate(res.NamespacedResourceG, m_core_v1.PodTemplate):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'PodTemplate'),
        plural='podtemplates',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class ReplicationControllerScale(res.NamespacedSubResource, m_autoscaling_v1.Scale):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('autoscaling', 'v1', 'Scale'),
        parent=res.ResourceDef('', 'v1', 'ReplicationController'),
        plural='replicationcontrollers',
        verbs=['get', 'patch', 'put'],
        action='scale',
    )


class ReplicationControllerStatus(res.NamespacedSubResource, m_core_v1.ReplicationController):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ReplicationController'),
        parent=res.ResourceDef('', 'v1', 'ReplicationController'),
        plural='replicationcontrollers',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class ReplicationController(res.NamespacedResourceG, m_core_v1.ReplicationController):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ReplicationController'),
        plural='replicationcontrollers',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Scale: ClassVar = ReplicationControllerScale
    Status: ClassVar = ReplicationControllerStatus


class ResourceQuotaStatus(res.NamespacedSubResource, m_core_v1.ResourceQuota):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ResourceQuota'),
        parent=res.ResourceDef('', 'v1', 'ResourceQuota'),
        plural='resourcequotas',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class ResourceQuota(res.NamespacedResourceG, m_core_v1.ResourceQuota):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ResourceQuota'),
        plural='resourcequotas',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = ResourceQuotaStatus


class Secret(res.NamespacedResourceG, m_core_v1.Secret):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Secret'),
        plural='secrets',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class ServiceAccount(res.NamespacedResourceG, m_core_v1.ServiceAccount):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'ServiceAccount'),
        plural='serviceaccounts',
        verbs=['delete', 'deletecollection', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )


class ServiceStatus(res.NamespacedSubResource, m_core_v1.Service):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Service'),
        parent=res.ResourceDef('', 'v1', 'Service'),
        plural='services',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class Service(res.NamespacedResourceG, m_core_v1.Service):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Service'),
        plural='services',
        verbs=['delete', 'get', 'global_list', 'global_watch', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = ServiceStatus


class NodeStatus(res.GlobalSubResource, m_core_v1.Node):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Node'),
        parent=res.ResourceDef('', 'v1', 'Node'),
        plural='nodes',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class Node(res.GlobalResource, m_core_v1.Node):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'Node'),
        plural='nodes',
        verbs=['delete', 'deletecollection', 'get', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = NodeStatus


class PersistentVolumeStatus(res.GlobalSubResource, m_core_v1.PersistentVolume):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'PersistentVolume'),
        parent=res.ResourceDef('', 'v1', 'PersistentVolume'),
        plural='persistentvolumes',
        verbs=['get', 'patch', 'put'],
        action='status',
    )


class PersistentVolume(res.GlobalResource, m_core_v1.PersistentVolume):
    api_info = res.ApiInfo(
        resource=res.ResourceDef('', 'v1', 'PersistentVolume'),
        plural='persistentvolumes',
        verbs=['delete', 'deletecollection', 'get', 'list', 'patch', 'post', 'put', 'watch'],
    )

    Status: ClassVar = PersistentVolumeStatus

